/*
 * BitmapComponent.java
 * 17. November 2007, 19:24
 */

package de.siedler_maps.mapinstaller.widgets;

import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;

/** A class to paint a bitmap graphic. */
public class BitmapComponent extends Canvas
{
    private Image bitmap;
    
    /** Creates a bitmap component with a given filename. */
    public BitmapComponent(String filename)
    {
        super();
        
        bitmap = getToolkit().getImage(getClass().getResource(filename));
        loadImage();
    }
    
    /** Creates a bitmap component with a given image. */
    public BitmapComponent(Image bitmap)
    {
        super();
        this.bitmap = bitmap;
        loadImage();
    }
    
    private void loadImage()
    {
        MediaTracker mt = new MediaTracker(this);

        mt.addImage(bitmap, 0);
        try
        {
            mt.waitForAll();
        }
        catch (InterruptedException ex)
        {
        }
    }

    @Override
    public void paint(Graphics g)
    {
        g.drawImage(bitmap, 0, 0, this);
    }
    
    @Override
    public Dimension getPreferredSize()
    {
        return getMinimumSize();
    }

    @Override
    public Dimension getMinimumSize()
    {
        return new Dimension(bitmap.getWidth(this), bitmap.getHeight(this));
    }
}
